// fpDlg.h : header file
//

#pragma once


#include "ArrowButton.h"
#include "NoNotifyEdit.h"

// CfpDlg dialog
class CfpDlg : public CDialog
{
// Construction
public:
        CfpDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
        enum { IDD = IDD_FP_DIALOG };

        protected:
        virtual void DoDataExchange(CDataExchange* pDX);        // DDX/DDV support


// Implementation
protected:
        HICON m_hIcon;
        void BitsToFP();
        void FPToBits();
        void updateControls();
        
        typedef union _dint {
           double d;
           ULONGLONG n;
           _dint() { n = 0; }
        } dint;

        dint number; // the number shown in the bits control
        dint number1; // first operand
        dint number2; // second operand
        dint number3; // result
        dint NaNPlus; // generic +NaN
        dint NaNMinus; // generic -Nan
        dint InfPlus; // +Inf
        dint InfMinus; // -Inf

        BOOL initialized;
        
        void ShowNumber(dint & num, CEdit & fmt, CNoNotifyEdit & target);

        // Generated message map functions
        virtual BOOL OnInitDialog();
        afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
        afx_msg void OnPaint();
        afx_msg HCURSOR OnQueryDragIcon();
        afx_msg void OnBitChanged(UINT id);
        afx_msg void OnUpdateRequest();
        afx_msg void OnBnClickedSetFormatNumberN();
        afx_msg void OnBnClickedSetFormat1();
        afx_msg void OnBnClickedSetFormat2();
        afx_msg void OnBnClickedSetFormat3();
        afx_msg void OnChangeNumber();
        afx_msg void OnBnClickedNaNPlus();
        afx_msg void OnBnClickedNaNMinus();
        afx_msg void OnBnClickedInfPlus();
        afx_msg void OnBnClickedInfMinus();
        afx_msg void OnBnClickedShowSpaces();
        afx_msg void OnBnClicked1To2();
        afx_msg void OnBnClicked1To3();
        afx_msg void OnBnClicked2To1();
        afx_msg void OnBnClicked2To3();
        afx_msg void OnBnClicked3To1();
        afx_msg void OnBnClicked3To2();
        afx_msg void OnBnClickedNumberTo1();
        afx_msg void OnBnClickedNumberTo2();
        afx_msg void OnBnClickedNumberTo3();
        afx_msg void OnBnClickedAdd();
        afx_msg void OnBnClickedSubtract();
        afx_msg void OnBnClickedMultiply();
        afx_msg void OnBnClickedDivide();
        afx_msg void OnChangeHexMantissa();
        afx_msg void OnChangeBinaryExponent();
        afx_msg void OnChangeExcess1024Exponent();
        afx_msg void OnChangeNumber1();
        afx_msg void OnChangeNumber2();
        afx_msg void OnChangeNumber3();
        afx_msg void OnBnClickedFrom1();
        afx_msg void OnBnClickedFrom2();
        afx_msg void OnBnClickedFrom3();
        afx_msg void OnSetAllMantissa();
        afx_msg void OnClearAllMantissa();
        afx_msg void OnSetAllExponent();
        afx_msg void OnClearAllExponent();
        afx_msg void OnZeroExponent();

        DECLARE_MESSAGE_MAP()

        CArrowButton c_SetFormatN;
        CArrowButton c_SetFormat1;
        CArrowButton c_SetFormat2;
        CArrowButton c_SetFormat3;
        CArrowButton c_NumberTo1;
        CArrowButton c_NumberTo2;
        CArrowButton c_NumberTo3;
        CArrowButton c_3ToNumber;
        CArrowButton c_2ToNumber;
        CArrowButton c_1ToNumber;
        CArrowButton c_1To2;
        CArrowButton c_1To3;
        CArrowButton c_2To1;
        CArrowButton c_2To3;
        CArrowButton c_3To1;
        CArrowButton c_3To2;
        CButton c_ShowSpaces;
        CNoNotifyEdit c_HexMantissa;
        CNoNotifyEdit c_Number;
        CNoNotifyEdit c_Number1;
        CNoNotifyEdit c_Number2;
        CNoNotifyEdit c_Number3;
        CEdit c_FormatN;
        CEdit c_Format1;
        CEdit c_Format2;
        CEdit c_Format3;
        CNoNotifyEdit c_BinaryExponent;
        CNoNotifyEdit c_Excess1024Exponent;
        CButton c_FormatMinus;
        CButton c_FormatPlus;
        CButton c_FormatZero;
        CButton c_FormatHash;
        CButton c_FormatBlank;
        CButton c_WidthNone;
        CButton c_UseWidth;
        CEdit c_Width;
        CSpinButtonCtrl c_SpinWidth;
        CButton c_PrecisionNone;
        CButton c_UsePrecision;
        CEdit c_Precision;
        CSpinButtonCtrl c_SpinPrecision;
        CButton c_Type_e;
        CButton c_Type_E;
        CButton c_Type_f;
        CButton c_Type_g;
        CButton c_Type_G;
        CStatic c_Dot;
        CEdit c_Format;
        CSpinButtonCtrl c_SpinBinaryExponent;
        CSpinButtonCtrl c_SpinExcess1024Exponent;
        virtual void OnOK();
        virtual void OnCancel();
public:
    afx_msg void OnClose();
};
